//+------------------------------------------------------------------+
//|                                                           vl.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Green

extern int       Len=24;
extern int       Cnt=3000;
extern int       BBPeriod=120;
extern int       BBotkl=2;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);

 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int j = 0;
  int i,limit;
   double hhh, lll, sum, summinus, barsum, barsumminus;
   limit=Bars-counted_bars;
   if (limit> Cnt)  limit=Cnt;
   
   for(i = limit; i >= 0; i--) {
      j = 0;
      sum = 0;
      summinus = 0;
      hhh =0;
      lll = 999999;
      while (j<Len)   
      {
          barsum = 0;
          barsumminus = 0;
          
         {
            
            int shift = i+j; 
            datetime dt = iTime( Symbol(), NULL, shift); 
            int a = iBarShift( Symbol(), PERIOD_M1, dt, false);
            int kolvo = a-MathRound(Period()/PERIOD_M1);
            if (kolvo < 0 ) {kolvo=0;}
            for (int kk=a;kk>=kolvo;kk--) 
            {
               double ooo = iOpen(NULL, PERIOD_M1, kk);
               double ccc = iClose(NULL, PERIOD_M1, kk);
               double hh = iHigh(NULL, PERIOD_M1, kk);
               double ll = iLow(NULL, PERIOD_M1, kk);
               double vv = iVolume(NULL, PERIOD_M1, kk);
               
               if (hh> hhh)
               {
                  hhh = hh;

                     barsum = barsum + vv*ccc;

                  
               }
               if (lll> ll)
               {
                  lll = ll;

                    barsumminus = barsumminus + vv*ccc;

                  
               }               
               
            }            
         }

         sum = sum + barsum ;
         summinus = summinus + barsumminus ;


         j++;
      }

ExtMapBuffer1[i] = sum/summinus;

for(int k = limit; k >= 0; k--) {
ExtMapBuffer2[k]=iBandsOnArray(ExtMapBuffer1,0,BBPeriod,BBotkl,0,MODE_UPPER,k);
}

   }  
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+